#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "font.h"

#include <number/number_0.xbm>
#include <number/number_1.xbm>
#include <number/number_2.xbm>
#include <number/number_3.xbm>
#include <number/number_4.xbm>
#include <number/number_5.xbm>
#include <number/number_6.xbm>
#include <number/number_7.xbm>
#include <number/number_8.xbm>
#include <number/number_9.xbm>

#include <upper/upper_A.xbm>
#include <upper/upper_B.xbm>
#include <upper/upper_C.xbm>
#include <upper/upper_D.xbm>
#include <upper/upper_E.xbm>
#include <upper/upper_F.xbm>
#include <upper/upper_G.xbm>
#include <upper/upper_H.xbm>
#include <upper/upper_I.xbm>
#include <upper/upper_J.xbm>
#include <upper/upper_K.xbm>
#include <upper/upper_L.xbm>
#include <upper/upper_M.xbm>
#include <upper/upper_N.xbm>
#include <upper/upper_O.xbm>
#include <upper/upper_P.xbm>
#include <upper/upper_Q.xbm>
#include <upper/upper_R.xbm>
#include <upper/upper_S.xbm>
#include <upper/upper_T.xbm>
#include <upper/upper_U.xbm>
#include <upper/upper_V.xbm>
#include <upper/upper_W.xbm>
#include <upper/upper_X.xbm>
#include <upper/upper_Y.xbm>
#include <upper/upper_Z.xbm>

#include <lower/lower_a.xbm>
#include <lower/lower_b.xbm>
#include <lower/lower_c.xbm>
#include <lower/lower_d.xbm>
#include <lower/lower_e.xbm>
#include <lower/lower_f.xbm>
#include <lower/lower_g.xbm>
#include <lower/lower_h.xbm>
#include <lower/lower_i.xbm>
#include <lower/lower_j.xbm>
#include <lower/lower_k.xbm>
#include <lower/lower_l.xbm>
#include <lower/lower_m.xbm>
#include <lower/lower_n.xbm>
#include <lower/lower_o.xbm>
#include <lower/lower_p.xbm>
#include <lower/lower_q.xbm>
#include <lower/lower_r.xbm>
#include <lower/lower_s.xbm>
#include <lower/lower_t.xbm>
#include <lower/lower_u.xbm>
#include <lower/lower_v.xbm>
#include <lower/lower_w.xbm>
#include <lower/lower_x.xbm>
#include <lower/lower_y.xbm>
#include <lower/lower_z.xbm>

#include <mark/ampersand.xbm>
#include <mark/asterisk.xbm>
#include <mark/at.xbm>
#include <mark/backquote.xbm>
#include <mark/backslash.xbm>
#include <mark/colon.xbm>
#include <mark/comma.xbm>
#include <mark/dollar.xbm>
#include <mark/double_quotation.xbm>
#include <mark/equal.xbm>
#include <mark/exclamation.xbm>
#include <mark/greater_than.xbm>
#include <mark/hash.xbm>
#include <mark/hat.xbm>
#include <mark/left_brace.xbm>
#include <mark/left_bracket.xbm>
#include <mark/left_parenthesis.xbm>
#include <mark/less_than.xbm>
#include <mark/minus.xbm>
#include <mark/percent.xbm>
#include <mark/period.xbm>
#include <mark/pipe.xbm>
#include <mark/plus.xbm>
#include <mark/question.xbm>
#include <mark/right_brace.xbm>
#include <mark/right_bracket.xbm>
#include <mark/right_parenthesis.xbm>
#include <mark/semicolon.xbm>
#include <mark/single_quotation.xbm>
#include <mark/slash.xbm>
#include <mark/space.xbm>
#include <mark/tilde.xbm>
#include <mark/underscore.xbm>

static struct font_bitmap {
  int width;
  int height;
  unsigned char *bits;
  unsigned char *image;
} fonts[] = {
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },

  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },

  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },

  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },
  { space_width, space_height, space_bits, NULL },

  { space_width, space_height, space_bits, NULL },
  { exclamation_width, exclamation_height, exclamation_bits, NULL },
  { double_quotation_width, double_quotation_height, double_quotation_bits, NULL },
  { hash_width, hash_height, hash_bits, NULL },
  { dollar_width, dollar_height, dollar_bits, NULL },
  { percent_width, percent_height, percent_bits, NULL },
  { ampersand_width, ampersand_height, ampersand_bits, NULL },
  { single_quotation_width, single_quotation_height, single_quotation_bits, NULL },
  { left_parenthesis_width, left_parenthesis_height, left_parenthesis_bits, NULL },
  { right_parenthesis_width, right_parenthesis_height, right_parenthesis_bits, NULL },
  { asterisk_width, asterisk_height, asterisk_bits, NULL },
  { plus_width, plus_height, plus_bits, NULL },
  { comma_width, comma_height, comma_bits, NULL },
  { minus_width, minus_height, minus_bits, NULL },
  { period_width, period_height, period_bits, NULL },
  { slash_width, slash_height, slash_bits, NULL },

  { number_0_width, number_0_height, number_0_bits, NULL },
  { number_1_width, number_1_height, number_1_bits, NULL },
  { number_2_width, number_2_height, number_2_bits, NULL },
  { number_3_width, number_3_height, number_3_bits, NULL },
  { number_4_width, number_4_height, number_4_bits, NULL },
  { number_5_width, number_5_height, number_5_bits, NULL },
  { number_6_width, number_6_height, number_6_bits, NULL },
  { number_7_width, number_7_height, number_7_bits, NULL },
  { number_8_width, number_8_height, number_8_bits, NULL },
  { number_9_width, number_9_height, number_9_bits, NULL },

  { colon_width, colon_height, colon_bits, NULL },
  { semicolon_width, semicolon_height, semicolon_bits, NULL },
  { less_than_width, less_than_height, less_than_bits, NULL },
  { equal_width, equal_height, equal_bits, NULL },
  { greater_than_width, greater_than_height, greater_than_bits, NULL },
  { question_width, question_height, question_bits, NULL },
  { at_width, at_height, at_bits, NULL },

  { upper_A_width, upper_A_height, upper_A_bits, NULL },
  { upper_B_width, upper_B_height, upper_B_bits, NULL },
  { upper_C_width, upper_C_height, upper_C_bits, NULL },
  { upper_D_width, upper_D_height, upper_D_bits, NULL },
  { upper_E_width, upper_E_height, upper_E_bits, NULL },
  { upper_F_width, upper_F_height, upper_F_bits, NULL },
  { upper_G_width, upper_G_height, upper_G_bits, NULL },
  { upper_H_width, upper_H_height, upper_H_bits, NULL },
  { upper_I_width, upper_I_height, upper_I_bits, NULL },
  { upper_J_width, upper_J_height, upper_J_bits, NULL },
  { upper_K_width, upper_K_height, upper_K_bits, NULL },
  { upper_L_width, upper_L_height, upper_L_bits, NULL },
  { upper_M_width, upper_M_height, upper_M_bits, NULL },
  { upper_N_width, upper_N_height, upper_N_bits, NULL },
  { upper_O_width, upper_O_height, upper_O_bits, NULL },
  { upper_P_width, upper_P_height, upper_P_bits, NULL },
  { upper_Q_width, upper_Q_height, upper_Q_bits, NULL },
  { upper_R_width, upper_R_height, upper_R_bits, NULL },
  { upper_S_width, upper_S_height, upper_S_bits, NULL },
  { upper_T_width, upper_T_height, upper_T_bits, NULL },
  { upper_U_width, upper_U_height, upper_U_bits, NULL },
  { upper_V_width, upper_V_height, upper_V_bits, NULL },
  { upper_W_width, upper_W_height, upper_W_bits, NULL },
  { upper_X_width, upper_X_height, upper_X_bits, NULL },
  { upper_Y_width, upper_Y_height, upper_Y_bits, NULL },
  { upper_Z_width, upper_Z_height, upper_Z_bits, NULL },

  { left_bracket_width, left_bracket_height, left_bracket_bits, NULL },
  { backslash_width, backslash_height, backslash_bits, NULL },
  { right_bracket_width, right_bracket_height, right_bracket_bits, NULL },
  { hat_width, hat_height, hat_bits, NULL },
  { underscore_width, underscore_height, underscore_bits, NULL },
  { backquote_width, backquote_height, backquote_bits, NULL },

  { lower_a_width, lower_a_height, lower_a_bits, NULL },
  { lower_b_width, lower_b_height, lower_b_bits, NULL },
  { lower_c_width, lower_c_height, lower_c_bits, NULL },
  { lower_d_width, lower_d_height, lower_d_bits, NULL },
  { lower_e_width, lower_e_height, lower_e_bits, NULL },
  { lower_f_width, lower_f_height, lower_f_bits, NULL },
  { lower_g_width, lower_g_height, lower_g_bits, NULL },
  { lower_h_width, lower_h_height, lower_h_bits, NULL },
  { lower_i_width, lower_i_height, lower_i_bits, NULL },
  { lower_j_width, lower_j_height, lower_j_bits, NULL },
  { lower_k_width, lower_k_height, lower_k_bits, NULL },
  { lower_l_width, lower_l_height, lower_l_bits, NULL },
  { lower_m_width, lower_m_height, lower_m_bits, NULL },
  { lower_n_width, lower_n_height, lower_n_bits, NULL },
  { lower_o_width, lower_o_height, lower_o_bits, NULL },
  { lower_p_width, lower_p_height, lower_p_bits, NULL },
  { lower_q_width, lower_q_height, lower_q_bits, NULL },
  { lower_r_width, lower_r_height, lower_r_bits, NULL },
  { lower_s_width, lower_s_height, lower_s_bits, NULL },
  { lower_t_width, lower_t_height, lower_t_bits, NULL },
  { lower_u_width, lower_u_height, lower_u_bits, NULL },
  { lower_v_width, lower_v_height, lower_v_bits, NULL },
  { lower_w_width, lower_w_height, lower_w_bits, NULL },
  { lower_x_width, lower_x_height, lower_x_bits, NULL },
  { lower_y_width, lower_y_height, lower_y_bits, NULL },
  { lower_z_width, lower_z_height, lower_z_bits, NULL },

  { left_brace_width, left_brace_height, left_brace_bits, NULL },
  { pipe_width, pipe_height, pipe_bits, NULL },
  { right_brace_width, right_brace_height, right_brace_bits, NULL },
  { tilde_width, tilde_height, tilde_bits, NULL },
  { space_width, space_height, space_bits, NULL },

  { 0, 0, NULL, NULL },
};

#define FONTS_NUM (sizeof(fonts) / sizeof(fonts[0]))

int font_get_width(unsigned char c)
{
  c = (c < FONTS_NUM) ? c : 0;
  return fonts[c].width;
}

int font_get_height(unsigned char c)
{
  c = (c < FONTS_NUM) ? c : 0;
  return fonts[c].height;
}

int font_get_bit(unsigned char c, int x, int y)
{
  struct font_bitmap *fb;

  c = (c < FONTS_NUM) ? c : 0;
  fb = &fonts[c];
  if ((x < 0) || (x >= fb->width) || (y < 0) || (y >= fb->height))
    return 0;

  return (fb->bits[y * (fb->width / 8) + (x / 8)] & (1 << (x % 8))) ? 1 : 0;
}

int font_get_margin(unsigned char c, int *left_margin, int *right_margin)
{
  int x, y, w, h;
  int lmargin = -1, rmargin = 0;
  int min;

  w = font_get_width(c);
  h = font_get_height(c);
  for (x = 0; x < w; x++) {
    rmargin++;
    for (y = 0; y < h; y++) {
      if (font_get_bit(c, x, y)) {
	rmargin = 0;
	if (lmargin < 0)
	  lmargin = x;
      }
    }
  }

  min = w / 8;

  if (lmargin == w) lmargin = w / 2;
  if (rmargin == w) rmargin = w / 2;
  lmargin -= min;
  rmargin -= min;

  *left_margin  = lmargin;
  *right_margin = rmargin;

  return 0;
}

unsigned char *font_get_image_string(char *string, int *widthp, int *heightp,
				     unsigned long fg, unsigned long bg)
{
  char *p;
  int width, height, w, h, x, y, offset_x, offset_y, size;
  unsigned char *image, *ip;
  int left_margin, right_margin;

  width = height = 0;
  for (p = string; *p; p++) {
    w = font_get_width(*p);
    h = font_get_height(*p);
    font_get_margin(*p, &left_margin, &right_margin);
    width += w;
    width -= (left_margin + right_margin);
    if (height < h) height = h;
  }

  for (w = 1; w < width; w *= 2)
    ;
  offset_x = (w - width) / 2;
  width = w;

  for (h = 1; h < height; h *= 2)
    ;
  offset_y = (h - height) / 2;
  height = h;

  size = sizeof(unsigned char) * width * height * 4;
  image = malloc(size);
  memset(image, 0, size);

  for (x = 0; x < width; x++) {
    for (y = 0; y < height; y++) {
      ip = &image[(y * width + x) * 4];
      ip[0] = (bg >> 24) & 0xff; /* R */
      ip[1] = (bg >> 16) & 0xff; /* G */
      ip[2] = (bg >>  8) & 0xff; /* B */
      ip[3] =  bg        & 0xff; /* Alpha */
    }
  }

  for (p = string; *p; p++) {
    w = font_get_width(*p);
    h = font_get_height(*p);
    font_get_margin(*p, &left_margin, &right_margin);
    offset_x -= left_margin;
    for (x = 0; x < w; x++) {
      for (y = 0; y < h; y++) {
	if (font_get_bit(*p, x, y)) {
	  ip = &image[((y + offset_y) * width + (offset_x + x)) * 4];
	  ip[0] = (fg >> 24) & 0xff; /* R */
	  ip[1] = (fg >> 16) & 0xff; /* G */
	  ip[2] = (fg >>  8) & 0xff; /* B */
	  ip[3] =  fg        & 0xff; /* Alpha */
	}
      }
    }
    offset_x += w;
    offset_x -= right_margin;
  }

  if (widthp ) *widthp  = width;
  if (heightp) *heightp = height;

  return image;
}
